// demo.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "stdio.h"
#include <windows.h>

#define CN_KEY_TEXT_LEN		16
typedef bool (*func)(const char *, const char *, int , char *, int &);

void WriteFile(const char *pszFile, const char *pszContents, unsigned uSize)
{
	if (NULL == pszFile
		|| NULL == pszContents
		|| 0 == uSize)
	{
		return ;
	}

	FILE *pFile = fopen(pszFile, "wb");
	if (NULL == pFile)
	{
		return ;
	}

	fwrite(pszContents, uSize, 1, pFile);
	fclose(pFile);
}

/*
  ǰÿ16ֽڽмܵģĿbufferǴԴBuffer16
*/
int _tmain(int argc, _TCHAR* argv[])
{
	char *pSrcFile = "C:\\test.txt";
	char *pDstFile = "C:\\test.txt.en";
	char *pSecFile = "C:\\Security.enc";
	char *pkey = "mysecretkeyencry";

	FILE *pFile = fopen(pSrcFile, "rb");
	if (NULL == pFile)
	{
		return 1;
	}

	int nSrcSize = 0, nDstSize = 0, nSecurity = CN_KEY_TEXT_LEN;
	char *pSrc = NULL, *pDst = NULL, *pSecurity = NULL;
	
	fseek(pFile, 0, SEEK_END);
	nSrcSize = ftell(pFile);
	// ĿbuffĴСԴbuff
	// ĿbuffԴbuff16ֽ
	int nResidue = nSrcSize % CN_KEY_TEXT_LEN;
	nDstSize = (0 == nResidue) ? nSrcSize : (nSrcSize + CN_KEY_TEXT_LEN - nResidue);
	fseek(pFile, 0, SEEK_SET);

	pSrc = new char[nSrcSize + 1];
	pDst = new char[nDstSize + 1];
	pSecurity = new char[nSecurity + 1];
	memset(pSrc, 0, nSrcSize + 1);
	memset(pDst, 0, nDstSize + 1);
	memset(pSecurity, 0, nSecurity + 1);

	fread(pSrc, nSrcSize, 1, pFile);
	fclose(pFile);

	HINSTANCE hModule = LoadLibrary("yl_encode.dll");
	if (hModule != NULL) 
	{
		func encode = (func)GetProcAddress(hModule, "Yealink_Encode");
		if ( encode != NULL ) 
		{
			// cfgݽм
			encode(pkey, pSrc, nSrcSize, pDst, nDstSize);

			// Կм
			encode(NULL, pkey, strlen(pkey), pSecurity, nSecurity);
		}
		else 
		{
			printf("load the function fail\n");
		}
		FreeLibrary( hModule );
	}
	else
	{
		printf("load library fail\n");
	}

	// ɼļ
	WriteFile(pDstFile, pDst, nDstSize);

	// Security.enc
	WriteFile(pSecFile, pSecurity, nSecurity);
	
	delete []pSrc;
	delete []pDst;
	delete []pSecurity;

	getchar();
	return 0;
}

